package com.zanxiang.game.module.manage.websocket;

import com.zanxiang.erp.security.util.SecurityUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.connection.Message;
import org.springframework.data.redis.connection.MessageListener;
import org.springframework.stereotype.Component;
import org.springframework.web.socket.TextMessage;
import org.springframework.web.socket.WebSocketSession;

import java.io.IOException;

/**
 * @author : lingfeng
 * @time : 2024-02-23
 * @description : 客服消息redis监听器
 */
@Component
public class KfMsgRedisListener implements MessageListener {

    @Autowired
    private KfMsgWebSocketSessionRegistry kfMsgWebSocketSessionRegistry;

    @Override
    public void onMessage(Message message, byte[] pattern) {
        //从redis中拿到的消息
        String messageBody = new String(message.getBody());
        //从消息中获取userId
        WebSocketSession session = kfMsgWebSocketSessionRegistry.getSession(SecurityUtil.getUserId().toString());
        //判断连接存在, 且未来断开, 发送消息
        if (session != null && session.isOpen()) {
            try {
                session.sendMessage(new TextMessage(messageBody));
            } catch (IOException e) {
                // Handle exception
            }
        }
    }
}
